from rich.console import Console
from rich.table import Table, errors

def display(lookup_results):
    table = Table(title="results", highlight=True, show_lines=True, row_styles=["dim", ""]) 
    # Remember: the dimension/column is not the host type, but the lookup result! So a whois, a DMARC, an SPF, etc. Because for one host, there are multiple lookup results (I guess???)
    table.add_column('host')
    table.add_column('domain registered')
    table.add_column('registrar')
    table.add_column('dnssec')
    table.add_column('spf')
    table.add_column('dmarc')

    for lookedup in lookup_results:
        try:
            table.add_row(str(lookedup.host), str(lookedup.whois['creation_date']), str(lookedup.whois['registrar']), str(lookedup.whois['dnssec']), lookedup.spf, lookedup.dmarc)
        except errors.NotRenderableError as error:
            print(error.args, lookup_results, lookedup)
    table.add_section()
    table.add_row("", "", "", "", "*** -all = hard fail ***", "*** p=reject (drop email)***", style="green")
    table.add_row("", "", "", "", "*** ~all = hard fail ***", "*** p=quarantine (email in spam)***", style="green")
    table.add_row("", "", "", "", "*** all = allow all ***", "*** p=none (ignore email)***", style="green")

    console = Console()
    console.print(table)
