import validators

def normalize(host):
    domain_name, tld = "", ""
    if host.startswith('www.'):
        domain_name, tld = str.split(host,'.')[-2:]
        normalized_domain = domain_name + '.' + tld
        return normalized_domain
    else:
        return host

def type_hosts(hosts):
    validated_hosts = {
        "URLs": [],
        "domains": [],
        "IPs": [],
        "email": [],
        "hostnames": [],
    }
    URLs = []
    domains = []
    IPs = []
    email = []
    hostnames = []
    for host in hosts:
        if validators.url(host):
            URLs.append(host)
        elif validators.domain(host):
            domains.append(normalize(host))
        elif validators.ipv4(host) or validators.ipv6(host):
            IPs.append(host)
        elif validators.email(host):
            email.append(host)
        elif validators.hostname(host):
            hostnames.append(host)
        else:
            print("This is not a URL, IP, email address or hostname: ", host)
    validated_hosts["URLs"].extend([i for i in URLs])
    validated_hosts["domains"].extend([i for i in domains])
    validated_hosts["IPs"].extend([i for i in IPs])
    validated_hosts["email"].extend([i for i in email])
    validated_hosts["hostnames"].extend([i for i in hostnames])
    return validated_hosts
